#!/bin/bash






# hadoop 初始化
if [ "$LAN_IP_ADDRESS" == "${HADOOP[0]}" ]; then
    if [ ! -d "${HADOOP_HOME}/namenode" ]; then 
        # 启动 Zookeeper 集群
        for node in ${ZOOKEEPER[@]}; do
            ssh -p ${SSH_PORT:-22} -T $node "systemctl start zookeeper"
            _log "[$node] 节点启动 zookeeper ."
        done
        sleep 5   

        # 初始化 zkfc
        hdfs zkfc -formatZK -force &>/dev/null
        _log "[$LAN_IP_ADDRESS] 节点格式化 zkfc ."
        sleep 5

        # 启动 JournalNode
        for node in ${HADOOP[@]:2}; do
            ssh -p ${SSH_PORT:-22} -T $node "systemctl start hdp-journalnode"
            _log "[$node] 节点启动 hdp-journalnode ."
        done
        sleep 5

        # 初始化 NameNode1
        hdfs namenode -format -force &>/dev/null
        _log "[$LAN_IP_ADDRESS] 节点格式化 namenode ."

        # 启动 NameNode1
        systemctl start hdp-namenode
        _log "[$LAN_IP_ADDRESS] 节点启动 namenode ."
        sleep 5

        # 同步/启动 NameNode2
        ssh -p ${SSH_PORT:-22} -T ${HADOOP[1]} <<<-'EOF'
            hdfs namenode -bootstrapStandby -force
            systemctl start hdp-namenode
		EOF
        _log "[${HADOOP[1]}] 节点同步/启动 namenode ."
        sleep 5

        # 启动 Zkfc、ResourceManager
        for node in ${HADOOP[@]:0:2}; do
            ssh -p ${SSH_PORT:-22} -T $node "systemctl start hdp-zkfc hdp-resourcemanager"
            _log "[$node] 节点启动 hdp-zkfc、hdp-resourcemanager ."
        done

        # 启动 DataNode、hdp-nodemanager
        for node in ${HADOOP[@]:2}; do
            ssh -p ${SSH_PORT:-22} -T $node "systemctl start hdp-datanode hdp-nodemanager"
            _log "[$node] 节点启动 hdp-datanode、hdp-nodemanager."
        done
    fi
fi