### M30 基础环境部署

> 1. 下载解压安装脚本(第一个节点执行)

    rm -rf /home/install
    curl -s http://script.wh.hc-yun.com:3380/install.tgz | tar xz -C /home

> 2. 编辑配置&&下载软件安装包(第一个节点执行)

    vi /home/install/config.ini
    bash /home/install/download.sh

> 3. 安装服务(所有节点执行)

    bash /home/soft/script/install.sh

> 4. 初始化集群(大数据第一个节点执行)

    bash /home/soft/script/cluster/init-hadoop-ha.sh
    bash /home/soft/script/cluster/init-doris-ha.sh
    bash /home/soft/script/cluster/init-tdengine.sh
    bash /home/soft/script/cluster/init-mysql.sh

### 数据采集部署

> 下载微服务包

    /home/mango/start.sh download all 32G

> 创建配置





> 启动服务

    /home/mango/start.sh start all

> 查看服务状态

    /home/mango/start.sh status 1




https://github.com/yodamad/gitlab-emoji

time bash /home/soft/script/install.sh


time echo Yes | bash /home/soft/script/cluster/init-hadoop-ha.sh
time echo Yes | bash /home/soft/script/cluster/init-doris-ha.sh
time echo Yes | bash /home/soft/script/cluster/init-tdengine.sh
time echo Yes | bash /home/soft/script/cluster/init-mysql.sh


curl -L http://script.wh.hc-yun.com:3380/install/install.sh > /home/soft/script/install.sh
bash /home/soft/script/install.sh

/home/soft/script/05flink.sh



curl http://script.wh.hc-yun.com:3380/install/08mysql-ha.sh > /home/soft/script/08mysql-ha.sh
/home/soft/script/08mysql-ha.sh


curl http://script.wh.hc-yun.com:3380/install/06seatunnel.sh > /home/soft/script/06seatunnel.sh
/home/soft/script/06seatunnel.sh




curl -L http://script.wh.hc-yun.com:3380/install/status.sh > /usr/local/.mango/status.sh




curl http://script.wh.hc-yun.com:3380/install/08mysql.sh > /home/soft/script/08mysql.sh
/home/soft/script/08mysql.sh



# start
curl http://script.wh.hc-yun.com:3380/install/mango > /usr/local/.mango/mango
curl http://script.wh.hc-yun.com:3380/install/status.sh > /usr/local/.mango/status.sh


. /usr/local/.mango/function.sh

for node in ${SERVERS[@]}; do     ssh $node -T  "curl http://script.wh.hc-yun.com:3380/install/status.sh > /usr/local/.mango/status.sh"; done
for node in ${SERVERS[@]}; do     ssh $node -T  'curl http://script.wh.hc-yun.com:3380/install/mango > /usr/local/.mango/mango'; done


for node in ${SERVERS[@]}; do     ssh $node 'curl http://script.wh.hc-yun.com:3380/install/status.sh > /usr/local/.mango/status.sh'; done

for node in ${SERVERS[@]}; do     ssh $node 'curl http://script.wh.hc-yun.com:3380/install/function.sh > /usr/local/.mango/function.sh'; done


for node in ${SERVERS[@]}; do     ssh $node 'curl http://script.wh.hc-yun.com:3380/install/mango > /usr/local/.mango/mango'; done


for node in $DORIS_NODE; do
    ssh -T $node "rm -rf /home/hadoop/apache-doris-fe-1.2.4.1-bin-x86_64; /home/soft/script/07doris.sh"

done


mango status kafka


curl -s http://oss.hc-yun.com/mango_soft/hadoop-2.7.7-native.tgz | tar xz -C


. /usr/local/.mango/function.sh

for node in ${SERVERS[@]}; do     ssh $node -T  "curl http://script.wh.hc-yun.com:3380/install/05hbase.sh > /home/soft/script/05hbase.sh"; done
for node in ${SERVERS[@]}; do     ssh $node -T  "curl http://script.wh.hc-yun.com:3380/install/status.sh > /usr/local/.mango/status.sh"; done


rm -rf /home/hadoop/hbase-1.2.12-bin
bash /home/soft/script/install.sh


/home/soft/script/05hbase.sh 



curl http://script.wh.hc-yun.com:3380/install/cluster/init-tdengine.sh > /home/soft/script/cluster/init-tdengine.sh
bash /home/soft/script/cluster/init-tdengine.sh


curl http://script.wh.hc-yun.com:3380/install/cluster/init-mysql.sh > /home/soft/script/cluster/init-mysql.sh
time bash /home/soft/script/cluster/init-mysql.sh force
nohup  bash /home/soft/script/cluster/init-mysql.sh force &> /tmp/mysql.log &
tail -f /tmp/mysql.log



# hbase
grep -qr '/etc/profile' ${SOFT_INSTALL_DIR}/hbase-${HBASE_VER}/bin/hbase-daemon.sh || sed -ie '2a\. /etc/profile\n' ${SOFT_INSTALL_DIR}/hbase-${HBASE_VER}/bin/hbase-daemon.sh

# opentsdb
chown -Rf opentsdb:opentsdb ${SOFT_INSTALL_DIR}/opentsdb
grep -qr '/etc/profile' /usr/bin/tsdb || sed -ie '2a\. /etc/profile\n' /usr/bin/tsdb


curl -s http://oss.hc-yun.com/mango_soft/hadoop-2.7.7-native.tgz | tar xz -C 

/home/hadoop/hadoop-2.7.7
curl -s http://${HOSTNAME}:16010/master-status#userTables| grep -qw ${HOSTNAME},16020


hbase.cluster.distributed=true





确认 ZooKeeper 连接正常：
echo "ruok" | nc <zookeeper-host> 2181
# 应返回 `imok`
确认 HDFS 可用：
hdfs dfsadmin -report









# TODO 可以考虑 download 时候生成变量文件安装时候读取变量文件不需要再次产生

# 检查服务状态
function _get_service_status() {
    local service_list=$(awk '/systemctl start/{print $NF}' /etc/rc.d/rc.local)
    # 定义输出格式（第一列固定40字符宽度）
    local format="%-40s %-12s %-12s\n"
    
    echo '----------------------------------------------------------------------------------------------'
    printf "\033[32m${format}\033[0m" "${HOSTNAME}" "$(hostname -i)" "$(date +'%F %T')"
    # 格式化标题中文占用宽度*2，英文占用宽度*1
    printf "%-44s %-14s %-16s\n" "服务名称" "状态" "启动时间"
    echo '----------------------------------------------------------------------------------------------'
    
    for service in $service_list; do
        status=$(systemctl is-active $service 2>/dev/null)
        source_start_time=$(systemctl show $service --property ExecMainStartTimestamp --value 2>/dev/null)
        [ -z "$source_start_time" ] && start_time="N/A" || start_time=$(date -d "$source_start_time" +"%Y-%m-%d %H:%M:%S")
        # 带颜色格式化输出（注意ANSI颜色码长度不影响对齐）
        if [ "$status" == "active" ]; then
            printf "\033[32m${format}\033[0m" "$service" "$status" "$start_time"
        else
            printf "\033[31m${format}\033[0m" "$service" "$status" "$start_time"
        fi
    done
}


_get_service_status

for NODE in ${SERVERS[@]}; do
    ssh  -T ${NODE} "$(declare -f _get_service_status); _get_service_status"
done






### beszel 监控端配置

> 1. 初始化用户

```
curl 'http://127.0.0.1:8090/api/beszel/create-user' \
  -H 'Content-Type: application/json' \
  --data-raw '{"email":"xiongjunfeng@haocang.com","password":"zaq1@WSX"}'
```

> 2. 配置告警

```
# 获取 token
token=$(curl -s 'http://127.0.0.1:8090/api/collections/_superusers/auth-with-password' -H 'Content-Type: application/json' --data-raw '{"identity":"xiongjunfeng@haocang.com","password":"zaq1@WSX"}' | grep -oP '"token":\s*"\K[^"]*')


# 配置邮件服务器信息
curl 'http://127.0.0.1:8090/api/settings' \
  -X 'PATCH' \
  -H "Authorization: $token" \
  -H 'Content-Type: application/json' \
  --data-raw '{"meta":{"appName":"Beszel","appURL":"http://localhost:8090","senderName":"xiongjunfeng@haocang.com","senderAddress":"xiongjunfeng@haocang.com","hideControls":true},"smtp":{"enabled":true,"port":465,"host":"smtphz.qiye.163.com","username":"xiongjunfeng@haocang.com","authMethod":"PLAIN","tls":true,"localName":"","password":"15YPw2KGNQULGGQM"}}'

# 测试邮件
curl 'http://127.0.0.1:8090/api/settings/test/email' \
  -H "Authorization: $token" \
  -H 'Content-Type: application/json' \
  --data-raw '{"email":"xiongjunfeng@haocang.com","template":"verification","collection":"pbc_3142635823"}'
```

> 通过配置文件添加资源

```
beszel_home=/usr/local/beszel
echo 'systems:' > $beszel_home/beszel_data/config.yml
for ip in 192.168.10.31 192.168.10.{61..74}; do
cat <<EOF >> $beszel_home/beszel_data/config.yml
    - name: vm-node${ip##*.}
      host: ${ip}
      port: 45876
      users:
        - xiongjunfeng@haocang.com
EOF
done

systemctl restart beszel-hub
```


### CURL添加资源

```
TOKEN=$(curl -s 'http://192.168.10.61:8090/api/collections/users/auth-with-password' -H 'Content-Type: application/json' --data-raw '{"identity":"xiongjunfeng@haocang.com","password":"zaq1@WSX"}' | grep -oP '"token":\s*"\K[^"]*')

for ip in 192.168.10.{61..74}; do
    DATA_RAW="{\"name\":\"vm-node${ip##*.}\",\"host\":\"${ip}\",\"port\":\"45876\",\"users\":\"a27a74nri3271gs\"}"
    curl 'http://192.168.10.61:8090/api/collections/systems/records' \
        -H "Authorization: $TOKEN" \
        -H 'Content-Type: application/json' \
        --data-raw $DATA_RAW \
        --insecure
done
```

### 创建静态配置添加资源

```

echo 'systems:' > beszel_data/config.yml
for ip in 192.168.10.{61..74}; do
cat <<EOF >> beszel_data/config.yml
    - name: vm-node${ip##*.}
      host: ${ip}
      port: 45876
      users:
        - xiongjunfeng@haocang.com
EOF
done
```

### 配置邮箱告警

```
# 获取 token
token=$(curl -s 'http://192.168.10.61:8090/api/collections/_superusers/auth-with-password' -H 'Content-Type: application/json' --data-raw '{"identity":"xiongjunfeng@haocang.com","password":"zaq1@WSX"}' | grep -oP '"token":\s*"\K[^"]*')

# 配置邮件服务器信息
curl 'http://192.168.10.61:8090/api/settings' \
  -X 'PATCH' \
  -H 'Authorization: eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJjb2xsZWN0aW9uSWQiOiJwYmNfMzE0MjYzNTgyMyIsImV4cCI6MTc0MzI0NTc1MSwiaWQiOiIwMGkwMzk2NG92MjczMjAiLCJyZWZyZXNoYWJsZSI6dHJ1ZSwidHlwZSI6ImF1dGgifQ.P9tPKJrLze26KVvUAm-LLUuDlkVP3Q67tSSZop7cDsg' \
  --data-raw '{"meta":{"appName":"Beszel","appURL":"http://localhost:8090","senderName":"xiongjunfeng@haocang.com","senderAddress":"xiongjunfeng@haocang.com","hideControls":true},"smtp":{"enabled":true,"port":465,"host":"smtphz.qiye.163.com","username":"xiongjunfeng@haocang.com","authMethod":"PLAIN","tls":true,"localName":"","password":"15YPw2KGNQULGGQM"}}' \
  --insecure


curl 'http://127.0.0.1:8090/api/settings'   \
    -X 'PATCH'   \
    -H 'Authorization: eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJjb2xsZWN0aW9uSWQiOiJwYmNfMzE0MjYzNTgyMyIsImV4cCI6MTc0MzI0NTMzMSwiaWQiOiJmcmMyMHJwaXk4aTUzZTYiLCJyZWZyZXNoYWJsZSI6dHJ1ZSwidHlwZSI6ImF1dGgifQ.8FBx2gFzeANixiQTm_K-qlko2RhazeeHGrS3ArM4834'  \
    -H 'Content-Type: application/json'   --data-raw '{"meta":{"appName":"Beszel","appURL":"http://localhost:8090","senderName":"xiongjunfeng@haocang.com","senderAddress":"xiongjunfeng@haocang.com","hideControls":true},"smtp":{"enabled":true,"port":465,"host":"smtphz.qiye.163.com","username":"xiongjunfeng@haocang.com","authMethod":"PLAIN","tls":true,"localName":"","password":"15YPw2KGNQULGGQM"}}'   --insecure




# 测试邮件
curl 'http://192.168.10.61:8090/api/settings/test/email' \
  -H "Authorization: $token" \
  -H 'Content-Type: application/json' \


  --data-raw '{"email":"xiongjunfeng@haocang.com","template":"verification","collection":"pbc_3142635823"}' \
  --insecure
```

###  微服务开机自动

```
mkdir -p /script
cat <<'EOF'   > /script/start_mango.sh
#!/bin/bash

# 加载系统环境变量
source /etc/profile

# 定义依赖服务
TARGET_SERVICES=(
    172.31.32.142:2181   # Zookeeper
    172.31.32.142:9092   # Kafka
    172.31.32.146:8848   # nacos
    172.31.32.120:3306   # mysql
    172.31.32.144:6379   # redis
    172.31.32.177:6030   # tdengine
)

# 日志文件
LOG_FILE="/tmp/start_mango.log"

# 日志输出函数
log() {
    local level="$1"
    local message="$2"
    printf -- "[%s] [%-5s] %s\n" "$(date '+%F %T')" "$level" "$message"
}

# 带重试机制的端口检测
wait_for_port() {
    local ip="$1"
    local port="$2"
    
    until nc -zvw1 "$ip" "$port" &> /dev/null; do
        log "INFO" "等待服务可用: $ip:$port..."
        sleep 3
    done
}

# 主执行流程
main() {
    # 端口检测循环
    for service in "${TARGET_SERVICES[@]}"; do
        IFS=':' read -ra addr <<< "$service"
        local ip="${addr[0]}"
        local port="${addr[1]}"

        log "INFO" "开始检查服务 | IP: $ip | 端口: $port"
        wait_for_port "$ip" "$port"
        log "INFO" "服务可用确认 | IP: $ip | 端口: $port"
    done

    # 启动微服务
    log "INFO" "开始启动微服务..."
    /home/mango/start.sh start all
}

# 执行入口（统一处理日志重定向）
{
    main "$@"
} > "$LOG_FILE" 2>&1

exit 0
EOF


chmod +x /script/start_mango.sh


cat <<'EOF'   >> /etc/start_all
#!/bin/bash

active=$1
case $active in
  start)
    /script/start_mango.sh
    ;;
  stop)
    /home/mango/start.sh stop all &>> /tmp/stop_mango.log
    ;;
  *)
    echo "$0 {stop|start}"
    ;;
esac
EOF

chmod +x  /etc/start_all



cat <<'EOF'  > /etc/systemd/system/start_mango.service
[Unit]
Description=Start Mango Script at Boot
After=network.target

[Service]
Type=simple
Environment=SERVICE_MODE=systemctl
ExecStart=/etc/start_all start

TimeoutSec=0
RemainAfterExit=yes

[Install]
WantedBy=multi-user.target
EOF

systemctl daemon-reload
systemctl enable start_mango.service
systemctl start start_mango.service


```




### 通过 systemctl 服务名称查询监听端口

```

# 终极排除线程方法
SERVICE=hdp-namenode
MAIN_PID=$(systemctl show -p MainPID "$SERVICE" | cut -d= -f2)
ALL_PIDS=$(pstree -p $MAIN_PID | sed 's/{[^}]*}([0-9]*)//g' | grep -oP '\(\K\d+' | paste -sd,)

ps -p $ALL_PIDS -o pid,ppid,cmd:512,comm

ss -ltnp | awk -v pids="$ALL_PIDS" '
  BEGIN { split(pids, pid_list, /,/) }
  {
    for (i in pid_list) {
      if ($6 ~ "pid=" pid_list[i] "," || $6 ~ "pid=" pid_list[i] "$") {
        split($4, a, /:/);
        port = a[length(a)];
        if (port != "") print port;
        break;
      }
    }
  }' | sort -u


cat /proc/$ALL_PIDS/cmdline | tr '\0' ' '
```


### 小昊 nginx 配置

```
        # 前端页面
        location / {
            proxy_pass  http://10.200.4.111:801;
        }

        location /paddlespeech/asr/streaming {
            # 启用基本认证
            auth_basic "Restricted Access";

            # 指定密码文件的位置
            auth_basic_user_file  htpasswd;

            # 添加验证请求头，其中 xxxxXXXX 是之前获取的 Base64编码
            proxy_set_header Authorization "Basic aGN4aWFvaGFvOnphcTFAV1NY";

            # 隐藏上游服务返回的 WWW-Authenticate 请求，阻止浏览器弹出登录窗口
            proxy_hide_header WWW-Authenticate;

            proxy_pass http://10.200.4.111:801/paddlespeech/asr/streaming; 
            proxy_set_header Host $host; 
            proxy_set_header Upgrade $http_upgrade; 
            proxy_set_header Connection 'Upgrade'; 
            proxy_set_header X-Real-IP $remote_addr; 
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for; 
            proxy_set_header X-Forwarded-Proto $scheme; 
            proxy_http_version 1.1; 
            proxy_redirect off; 
        }

        location /paddlespeech/tts/streaming {
            # 启用基本认证
            auth_basic "Restricted Access";

            # 指定密码文件的位置
            auth_basic_user_file  htpasswd;

            # 添加验证请求头，其中 xxxxXXXX 是之前获取的 Base64编码
            proxy_set_header Authorization "Basic aGN4aWFvaGFvOnphcTFAV1NY";

            # 隐藏上游服务返回的 WWW-Authenticate 请求，阻止浏览器弹出登录窗口
            proxy_hide_header WWW-Authenticate;

            proxy_pass http://10.200.4.111:801/paddlespeech/tts/streaming; 
            proxy_set_header Host $host; 
            proxy_set_header Upgrade $http_upgrade; 
            proxy_set_header Connection 'upgrade'; 
            proxy_set_header X-Real-IP $remote_addr; 
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for; 

            proxy_http_version 1.1; 
            proxy_redirect off; 
        }

        location = /ai/api/chat/modelList {
            proxy_pass http://10.200.4.111:801;                                        # 反向���理转发地址
            proxy_set_header Host $host;                                    # http请求的主机域名
            proxy_set_header X-Real-IP $remote_addr;                        # 远端真实ip地址
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;    # 反向代理之后转发之前的ip地址
            proxy_set_header X-Forwarded-Host $http_host;                   # 原始host值
            proxy_set_header X-Forwarded-Proto $scheme;                     # 原始协议类型
            proxy_set_header X-NginX-Proxy true;                            # nginx代理

            # sse协议配置
            proxy_http_version 1.1;          # 必须使用HTTP 1.1协议
            proxy_set_header Connection '';  # 清空默认连接头
            proxy_buffering off;             # 禁用响应缓冲（关键配置）
            proxy_cache off;                 # 关闭缓存
        }

        location = /ai/api/chat/streamChat {
            proxy_pass http://10.200.4.111:801;                                        # 反向���理转发地址
            proxy_set_header Host $host;                                    # http请求的主机域名
            proxy_set_header X-Real-IP $remote_addr;                        # 远端真实ip地址
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;    # 反向代理之后转发之前的ip地址
            proxy_set_header X-Forwarded-Host $http_host;                   # 原始host值
            proxy_set_header X-Forwarded-Proto $scheme;                     # 原始协议类型
            proxy_set_header X-NginX-Proxy true;                            # nginx代理

            # sse协议配置
            proxy_http_version 1.1;          # 必须使用HTTP 1.1协议
            proxy_set_header Connection '';  # 清空默认连接头
            proxy_buffering off;             # 禁用响应缓冲（关键配置）
            proxy_cache off;                 # 关闭缓存
        }
```

### 小昊测试

```
curl -i -N -H "Connection: Upgrade" \
    -H "Upgrade: websocket" \
    -H "Sec-WebSocket-Key: 6+4+CD+tWz31LVdKT+S1MA==" \
    -H "Sec-WebSocket-Version: 13" \
    -H "Authorization: Basic $(echo -n 'hcxiaohao:zaq1@WSX' | base64)" \
    -k https://10.250.0.137:801/paddlespeech/tts/streaming


curl -i -N -H "Connection: Upgrade" \
    -H "Upgrade: websocket" \
    -H "Sec-WebSocket-Key: 6+4+CD+tWz31LVdKT+S1MA==" \
    -H "Sec-WebSocket-Version: 13" \
    -H "Authorization: Basic $(echo -n 'hcxiaohao:zaq1@WSX' | base64)" \
    -k https://10.250.0.137:801/paddlespeech/asr/streaming
```