#!/bin/bash

# 检查IP是否存活
# 1. 检查是否能ping通
# 2. 检查端口是否开放
# 3. 输出存活IP
# 4. 输出不存活IP


cat <<EOF  > /dev/null
curl -s http://script.wh.hc-yun.com:3380/install/check_ip.sh | bash -s -- check 192.168.10
curl -s http://script.wh.hc-yun.com:3380/install/check_ip.sh | bash -s -- get
EOF



function check_ip() {
    local LAN_NET=${1:-192.168.2}

    cd /tmp && rm -f *.txt
    PORT_LIST='3389 22 443 80 8080 9100'
    for i in {1..254};do
        {
            IP=${LAN_NET}.${i}
            ping -c 2 $IP &>/dev/null
            if [ $? -ne 0 ];then
                for PORT in $PORT_LIST;do
                    nc -vw 1 $IP -z $PORT &>/dev/null
                    if [ $? -eq 0 ];then
                        echo $IP >> ok_ip.txt
                        exit 0
                    fi
                done
                echo $IP >>no_ip.txt
            else
                echo $IP >>ok_ip.txt
            fi
        }&
    done
}


case $1 in
    check)
        check_ip "$2"
        ;;
    get)
        cat /tmp/no_ip.txt | sort -t '.' -k4n | uniq
        ;;
    *)  
        echo "Usage: $0 [LAN_NET]"
        echo "Example: $0 192.168.2"
        echo "Example: $0 10.34.44"
        ;;
esac