#!/bin/bash

# hbase shell
# truncate 'tsdb-uid'
# truncate 'tsdb'

path_list='/home/tsdb-20240903_182017-inc '

for dir in $path_list; do
    table_name=$(basename $dir | awk -F '-[0-9]' '{print $1}')
    hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir
    if [ $? -ne 0 ]; then
        echo "执行失败：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir" | tee -a /tmp/hbase.log
    else
        echo "执行成功：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir" | tee -a /tmp/hbase.log
    fi
done


for dir in $path_list; do
    table_name=$(basename $dir | awk -F '-[0-9]' '{print $1}')
    if [ -d "$dir/_temporary/1" ]; then
        for sub_dir in $(ls $dir/_temporary/1 | grep -v '^_'); do
            hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/$sub_dir
            if [ $? -ne 0 ]; then
                echo "执行失败：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/$sub_dir" | tee -a /tmp/hbase.log
            else
                echo "执行成功：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/$sub_dir" | tee -a /tmp/hbase.log
            fi
        done
    fi
done


for dir in $path_list; do
    table_name=$(basename $dir | awk -F '-[0-9]' '{print $1}')
    if [ -d "$dir/_temporary/1/_temporary" ]; then
        for sub_dir in $(ls $dir/_temporary/1/_temporary | grep -v '^_'); do
            hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/_temporary/$sub_dir

            if [ $? -ne 0 ]; then
                echo "执行失败：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/_temporary/$sub_dir" | tee -a /tmp/hbase.log
            else
                echo "执行成功：hbase org.apache.hadoop.hbase.mapreduce.Import $table_name file://$dir/_temporary/1/_temporary/$sub_dir" | tee -a /tmp/hbase.log
            fi
        done
    fi
done