#!/bin/bash

# 获取当前路径
basedir=$(dirname "$(realpath "${BASH_SOURCE[0]}")")

# 读取配置文件
if [ -f "${basedir}/function.sh" ]; then
    . ${basedir}/function.sh
fi

# 安装包名称
name=jdk
PACKAGE=zulu${ZULU_JDK_VER}-linux_x64.tar.gz
INS_DIR=zulu${ZULU_JDK_VER}

# 检测安装状态
JAVA_HOME=${SOFT_INSTALL_DIR}/${INS_DIR}
if [ -d "${JAVA_HOME}" ]; then
    _info "本机已经安装 ${INS_DIR} ."
    exit 0
fi

green_echo ">>> 安装 $INS_DIR . ."

# 配置环境变量
update_env_marked JAVA_ENV "$(cat <<EOF
JAVA_HOME=${SOFT_INSTALL_DIR}/${INS_DIR}
JRE_HOME=\${JAVA_HOME}/jre
CLASSPATH=.:\$JAVA_HOME/lib/tools.jar:\$JAVA_HOME/lib/dt.jar:\$JRE_HOME/lib:\$CLASSPATH
pathmunge \$JAVA_HOME/bin before
export JAVA_HOME CLASSPATH
EOF
)"

# 准备软件安装包
if [ ! -f "${PACKAGE_DIR}/${PACKAGE}" ]; then
    retry_until_success curl -sL -o ${PACKAGE_DIR}/${PACKAGE} ${SERVER_URL}/${PACKAGE}
    _log "下载 >>> ${PACKAGE} ."
else
    true && _info "本机已存在软件包 ${PACKAGE} ."
fi

mkdir -p ${JAVA_HOME}
tar xf ${PACKAGE_DIR}/${PACKAGE} --strip-components=1 -C ${JAVA_HOME}
_log "解压 >>> ${PACKAGE}"

. /etc/profile &>/dev/null
java -version &>/dev/null
_log "验证环境 ."